# This is for Python version 3
# Caitlin Duncan, January 2014

import time
from random import randint

def binary_search(array, item):
    #przeszukuje liste liczb metoda binanrna 
    #i zwraca informacje o liczbie wykonanych porownan
    length = len(array)
    if length == 0:
        print("Blad: Lista jest pusta")
        return 0
    if length == 1:
        return 1
    count = 0
    while length > 0:
        count += 1
        middle = int(length/2)
        if array[middle] == item:
            return count
        elif array[middle] > item:
            array = array[:middle]
        else:
            array = array[(middle+1):]
        length = len(array)
    return 0

def linear_search(array, item):
    #przeszukuje liste liczb metoda sekwencyjna
    #i zwraca informacje o liczbie wykonanych porownan
    length = len(array)
    if length == 0:
        print("Blad: Lista jest pusta")
        return 0
    count = 0
    while count < length:
        if array[count] == item:
            count += 1
            return count
        count += 1
    return count

def test_binary(n):
    sample_list = range(n) #tworzy uporzdkowan n liste liczb
    item = randint(0, n)
    print("\nBinarne przeszukiwanie dla ", item, " na liscie ", n, " liczb")
    start = time.clock()
    comparisons_made = binary_search(sample_list, item)
    end = time.clock()
    print("Binarne przeszukiwanie dla ", n, " liczb: ", comparisons_made, " operacji porownywania")
    print("Czas: ", end - start, " sekund(y)")
    
    
def test_linear(n):
    sample_list = range(n) #create n keys in order
    item = randint(0, n)
    print("\nLiniowe przeszukiwanie dla ", item, " na liscie ", n, " liczb")
    start = time.clock()
    comparisons_made = linear_search(sample_list, item)
    end = time.clock()
    print("Liniowe przeszukiwanie dla ", n, " liczb:,", comparisons_made, "operacji porownywania")
    print("Czas: ", end - start, " sekund(y)")
    
    
    
# ponizej przyklad wywolania funkcji dla konkretnego eksperymentu
for number_of_keys in [10, 20, 50, 100, 1000]:
    for repeat_of_experiment in range(5):
        test_linear(number_of_keys)
    for repeat_of_experiment in range(5):
        test_binary(number_of_keys)
    